"""enemy character"""

import mob
import random
import projectile
import const

class Enemy(mob.Mob):
    maxvel = const.enemy_maxvel

    def __init__(self, g, coll_handler, x = 0, y = 0, type = 'eggboy'):
        super(Enemy, self).__init__(g, x, y, type)
        self.kind = 'enemy'
        self.coll_handler = coll_handler
        self.decision_timer = 0.0


    def collision(self, mob):
        self.moving = False
        if mob.kind == 'projectile':
            if mob.owner != self:
                self.coll_handler(self)


    # artificial intelligence
    def ai(self):
        self.decision_timer -= self.g.dt
        if self.decision_timer > 0.0:
            return
        self.decision_timer = random.random() * 5.0 + 1.0

        if int(random.random() * 5) == 0:
            # throw an egg
            #target = self.g.scene.moblist[int(random.random() * \
            #                                  len(self.g.scene.moblist))]
            target = self.g.scene.george
            self.throw(target.x, target.y)
        else:
            # move around
            self.dir = random.random() * 360.0
            self.vel = Enemy.maxvel
            self.moving = True

        
    def simstep(self):
        self.ai()
        super(Enemy, self).simstep()


    def throw(self, x = 0, y = 0):
        type = 'egg'
        proj = projectile.Projectile(self.g, self, x, y, type)
        self.g.scene.moblist.append(proj)

