"""pre-load images into a texture bin"""

import misc
import glob
import pyglet
import os

# Texbin doesn't work on Bob's computer
USE_TEXBIN = False

# Return a dictionary of images, represented as a texture bin
# Note that this gives a different texture target than a straight image load
# and may cause problems.
def imagedict():
    imgdict = {}
    # WARNING: some cards may not handle 1024x1024 textures!
    bin = pyglet.image.atlas.TextureBin(1024, 1024)
    for imgpath in glob.glob(misc.imagepath('*.png')):
        imgname = os.path.split(imgpath)[1].split('.')[0].lower()
        if imgname != 'grass_tex':
            if USE_TEXBIN:
                imgdict[imgname] = bin.add(pyglet.image.load(imgpath))
            else:
                imgdict[imgname] = pyglet.image.load(imgpath)
    return imgdict


# Separate bin just for grass, so that texture type is the same
def grassimg():
    bin = pyglet.image.atlas.TextureBin(256,256)
    img = pyglet.image.load(misc.imagepath('grass_tex.png'))
    return bin.add(img)

