import pyglet
import misc
import render
import testscene
import playlevel
import imagedict
import titlescreen
import winscreen
import losescreen

def main():
    g = Main()
    #pyglet.resource.path = ['data', 'data/gfx']
    #pyglet.resource.reindex()
    g.imagedict = imagedict.imagedict()
    # Uncomment next line and comment out 'playlevel_init' one to get editor
    #g.gamestate = 'testscene_init'
    #g.gamestate = 'playlevel_init'
    g.gamestate = 'titlescreen_init'
    g.update_interval = 1 / 60.0
    g.win = render.create_display(g)
    pyglet.clock.schedule_interval_soft(g.bigloop, g.update_interval)
    pyglet.app.run()


class Main(object):
    def bigloop(self,dt):
        """game main loop"""
        self.dt = dt
        if self.gamestate == 'testscene_init':
            self.scene = testscene.Testscene(self)
            self.gamestate = 'run'
        elif self.gamestate == 'playlevel_init':
            self.scene = playlevel.Playlevel(self)
            self.gamestate = 'run'
        elif self.gamestate == 'titlescreen_init':
            self.scene = titlescreen.Titlescreen(self)
            self.gamestate = 'run'
        elif self.gamestate == 'winscreen_init':
            self.scene = winscreen.Winscreen(self)
            self.gamestate = 'run'
        elif self.gamestate == 'loserscreen_init':
            self.scene = losescreen.Loserscreen(self)
            self.gamestate = 'run'
        elif self.gamestate == 'run':
            self.scene.run()
        elif self.gamestate == 'quit':
            print "Main loop ending, kthxbai!!!"
            pyglet.app.exit()
            exit()
        else:
            print "unknown state!"
