"""Press Any Key flasher"""

from pyglet.gl import *

class PressAnyKey(object):

    def __init__(self, g):
        self.image = g.imagedict['press_any_key']
        self.tex = self.image.get_texture()
        self.x = 0
        self.y = 0
        self.g = g
        self.t = 0.0


    def run(self):
        self.t += self.g.dt
        if self.t > 1.0:
            self.t = 0.0

    def draw(self):
        if self.t > 0.5:
            return
        offset = self.image.width / 2
        height = self.image.height
        #glTranslatef(self.x, self.y, 0.0)
        glEnable(self.tex.target)
        glBindTexture(self.tex.target, self.tex.id)
        t = self.tex.tex_coords
        glBegin(GL_QUADS)
        glTexCoord2f(t[0],t[1]); glVertex3f(-offset, 0.0, 0.0);
        glTexCoord2f(t[3],t[4]); glVertex3f( offset, 0.0, 0.0);
        glTexCoord2f(t[6],t[7]); glVertex3f( offset, height, 0.0);
        glTexCoord2f(t[9],t[10]); glVertex3f(-offset, height, 0.0);
        glEnd()
        
        
        
