"""projectiles"""

import mob
import random
import pyglet
import math

class Projectile(mob.Mob):
    maxvel = 800.0

    def __init__(self, g, owner, x = 0, y = 0, type = 'pillbottle1'):
        super(Projectile, self).__init__(g, owner.x, owner.y, type)
        self.kind = 'projectile'
        self.owner = owner
        self.move_to(x, y)
        self.vel = Projectile.maxvel
        self.active = True

    def collision(self, mob):
        # stop if we hit anything else after bouncing
        if self.active == False:
            if mob != self.last_hit:
                self.stop_moving(0)
        else:
            self.active = False
            self.last_hit = mob
            # bounce!
            vel = self.vel * (0.2 + random.random() * 0.1)
            dir = self.dir + 3 * math.pi - 0.1 + \
                  random.random() * math.pi * 0.2
            dir %= 2 * math.pi
            t = 0.2 + random.random() * 0.2
            newx = self.x + math.cos(dir) * vel * t
            newy = self.y + math.sin(dir) * vel * t
            self.move_to(newx, newy)
            pyglet.clock.schedule_once(self.stop_moving, t)
            

    def stop_moving(self, dt):
        print "ammo stopped moving"
        self.moving = False
        self.vel = 0.0

        
        

        
