"""Title screen"""

import camera
from pyglet.gl import *
import misc
import pyglet
from pyglet.window import key
import pressanykey

class Titlescreen(object):

    def __init__(self, g):
        self.g = g

        self.camera = camera.Camera()
        self.camera.xrot = 0.0
        self.camera.yrot = 0.0
        self.camera.xpos = 0.0
        self.camera.ypos = 0.0
        self.camera.zoom = -500.0

        self.titleimg = g.imagedict['titlescreen']
        self.titletex = self.titleimg.get_texture()

        self.titletheme = pyglet.media.Player()
        self.titletheme.volume = 0.3
        self.titletheme.queue(pyglet.media.load( \
            misc.soundpath('title_theme.mp3'), streaming = True))
        self.titletheme.play()

        self.pressany = pressanykey.PressAnyKey(self.g)


    def run(self):
        self.pressany.run()


    def on_mouse_drag(self, x, y, dx, dy, buttons, mods):
        pass

    def on_mouse_motion(self, x, y, dx, dy):
        pass

    def on_mouse_scroll(self, x, y, scroll_x, scroll_y):
        pass

    def on_mouse_press(self, x, y, buttons, mods):
        self.titletheme.pause()
        self.g.gamestate = 'playlevel_init'

    def on_key_press(self, keysym, mod):
        self.titletheme.pause()
        if keysym == key.E:
            self.g.gamestate = 'testscene_init'
        else:
            self.g.gamestate = 'playlevel_init'


    def on_draw(self):
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
        glLoadIdentity()
        glRotatef(self.camera.xrot,1.0,0.0,0.0);
        glRotatef(self.camera.yrot,0.0,0.0,1.0);
        glTranslatef(-self.camera.xpos, -self.camera.ypos, self.camera.zoom)

        self.x1, self.y1 = misc.old_screen_to_world(0, 0)
        self.x2, self.y2 = misc.old_screen_to_world( \
            self.g.win.width, self.g.win.height)

        glEnable(self.titletex.target)
        glBindTexture(self.titletex.target, self.titletex.id)
        t = self.titletex.tex_coords
        glBegin(GL_QUADS);
        glTexCoord2f(t[0], t[1])
        glVertex3f(self.x1, self.y1, 0.0);
        glTexCoord2f(t[3], t[4]);
        glVertex3f(self.x2, self.y1, 0.0);
        glTexCoord2f(t[6], t[7]);
        glVertex3f(self.x2, self.y2, 0.0);
        glTexCoord2f(t[9], t[10]);
        glVertex3f(self.x1, self.y2, 0.0);
        glEnd();

        self.pressany.x = self.x2 - self.x1
        self.pressany.y = self.y2 - self.y1
        self.pressany.draw() 
        
